AbstractQueue (Java SE 26 & JDK 26)
Description: declaration: module: java.base, package: java.util, class: AbstractQueue
Keywords: java.util.AbstractQueue class

# Class AbstractQueue<E>

java.lang.Object
java.util.AbstractCollection<E>
java.util.AbstractQueue<E>

Type Parameters:
  `E` - the type of elements held in this queue

All Implemented Interfaces:
  `Iterable<E>, Collection<E>, Queue<E>`

Direct Known Subclasses:
  `ArrayBlockingQueue, ConcurrentLinkedQueue, DelayQueue, LinkedBlockingDeque, LinkedBlockingQueue, LinkedTransferQueue, PriorityBlockingQueue, PriorityQueue, SynchronousQueue`

public abstract class AbstractQueue<E> extends AbstractCollection<E> implements Queue<E>
This class provides skeletal implementations of some `Queue` operations. The implementations in this class are appropriate when the base implementation does not allow `null` elements. Methods `add`, `remove`, and `element` are based on `offer`, `poll`, and `peek`, respectively, but throw exceptions instead of indicating failure via `false` or `null` returns.

A `Queue` implementation that extends this class must minimally define a method `Queue.offer(E)` which does not permit insertion of `null` elements, along with methods `Queue.peek()`, `Queue.poll()`, `Collection.size()`, and `Collection.iterator()`. Typically, additional methods will be overridden as well. If these requirements cannot be met, consider instead subclassing `AbstractCollection`.

This class is a member of the Java Collections Framework.

Since:
  1.5

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `AbstractQueue()`
  Constructor for use by subclasses.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `boolean`
  `add(E e)`
  Inserts the specified element into this queue if it is possible to do so immediately without violating capacity restrictions, returning `true` upon success and throwing an `IllegalStateException` if no space is currently available.
  `boolean`
  `addAll(Collection<? extends E> c)`
  Adds all of the elements in the specified collection to this queue.
  `void`
  `clear()`
  Removes all of the elements from this queue.
  `E`
  `element()`
  Retrieves, but does not remove, the head of this queue.
  `E`
  `remove()`
  Retrieves and removes the head of this queue.

  ### Methods declared in class AbstractCollection

  `contains, containsAll, isEmpty, iterator, remove, removeAll, retainAll, toArray, toArray, toString`
  Modifier and Type
  Method
  Description
  `boolean`
  `contains(Object o)`
  Returns `true` if this collection contains the specified element.
  `boolean`
  `containsAll(Collection<?> c)`
  Returns `true` if this collection contains all of the elements in the specified collection.
  `boolean`
  `isEmpty()`
  Returns `true` if this collection contains no elements.
  `abstract Iterator<E>`
  `iterator()`
  Returns an iterator over the elements contained in this collection.
  `boolean`
  `remove(Object o)`
  Removes a single instance of the specified element from this collection, if it is present (optional operation).
  `boolean`
  `removeAll(Collection<?> c)`
  Removes all of this collection's elements that are also contained in the specified collection (optional operation).
  `boolean`
  `retainAll(Collection<?> c)`
  Retains only the elements in this collection that are contained in the specified collection (optional operation).
  `Object[]`
  `toArray()`
  Returns an array containing all of the elements in this collection.
  `<T> T[]`
  `toArray(T[] a)`
  Returns an array containing all of the elements in this collection; the runtime type of the returned array is that of the specified array.
  `String`
  `toString()`
  Returns a string representation of this collection.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

  ### Methods declared in interface Collection

  `equals, hashCode, parallelStream, removeIf, size, spliterator, stream, toArray`
  Modifier and Type
  Method
  Description
  `boolean`
  `equals(Object o)`
  Compares the specified object with this collection for equality.
  `int`
  `hashCode()`
  Returns the hash code value for this collection.
  `default Stream<E>`
  `parallelStream()`
  Returns a possibly parallel `Stream` with this collection as its source.
  `default boolean`
  `removeIf(Predicate<? super E> filter)`
  Removes all of the elements of this collection that satisfy the given predicate (optional operation).
  `int`
  `size()`
  Returns the number of elements in this collection.
  `default Spliterator<E>`
  `spliterator()`
  Creates a `Spliterator` over the elements in this collection.
  `default Stream<E>`
  `stream()`
  Returns a sequential `Stream` with this collection as its source.
  `default <T> T[]`
  `toArray(IntFunction<T[]> generator)`
  Returns an array containing all of the elements in this collection, using the provided `generator` function to allocate the returned array.

  ### Methods declared in interface Iterable

  `forEach`
  Modifier and Type
  Method
  Description
  `default void`
  `forEach(Consumer<? super E> action)`
  Performs the given action for each element of the `Iterable` until all elements have been processed or the action throws an exception.

  ### Methods declared in interface Queue

  `offer, peek, poll`
  Modifier and Type
  Method
  Description
  `boolean`
  `offer(E e)`
  Inserts the specified element into this queue if it is possible to do so immediately without violating capacity restrictions.
  `E`
  `peek()`
  Retrieves, but does not remove, the head of this queue, or returns `null` if this queue is empty.
  `E`
  `poll()`
  Retrieves and removes the head of this queue, or returns `null` if this queue is empty.

- ## Constructor Details

  - ### AbstractQueue

    protected AbstractQueue()
    Constructor for use by subclasses.

- ## Method Details

  - ### add

    public boolean add(E e)
    Inserts the specified element into this queue if it is possible to do so immediately without violating capacity restrictions, returning `true` upon success and throwing an `IllegalStateException` if no space is currently available.

    This implementation returns `true` if `offer` succeeds, else throws an `IllegalStateException`.

    Specified by:
      `add` in interface `Collection<E>`
    Specified by:
      `add` in interface `Queue<E>`
    Overrides:
      `add` in class `AbstractCollection<E>`
    Parameters:
      `e` - the element to add
    Returns:
      `true` (as specified by `Collection.add(E)`)
    Throws:
      `IllegalStateException` - if the element cannot be added at this time due to capacity restrictions
      `ClassCastException` - if the class of the specified element prevents it from being added to this queue
      `NullPointerException` - if the specified element is null and this queue does not permit null elements
      `IllegalArgumentException` - if some property of this element prevents it from being added to this queue

  - ### remove

    public E remove()
    Retrieves and removes the head of this queue. This method differs from `poll` only in that it throws an exception if this queue is empty.

    This implementation returns the result of `poll` unless the queue is empty.

    Specified by:
      `remove` in interface `Queue<E>`
    Returns:
      the head of this queue
    Throws:
      `NoSuchElementException` - if this queue is empty

  - ### element

    public E element()
    Retrieves, but does not remove, the head of this queue. This method differs from `peek` only in that it throws an exception if this queue is empty.

    This implementation returns the result of `peek` unless the queue is empty.

    Specified by:
      `element` in interface `Queue<E>`
    Returns:
      the head of this queue
    Throws:
      `NoSuchElementException` - if this queue is empty

  - ### clear

    public void clear()
    Removes all of the elements from this queue. The queue will be empty after this call returns.

    This implementation repeatedly invokes `poll` until it returns `null`.

    Specified by:
      `clear` in interface `Collection<E>`
    Overrides:
      `clear` in class `AbstractCollection<E>`

  - ### addAll

    public boolean addAll(Collection<? extends E> c)
    Adds all of the elements in the specified collection to this queue. Attempts to addAll of a queue to itself result in `IllegalArgumentException`. Further, the behavior of this operation is undefined if the specified collection is modified while the operation is in progress.

    This implementation iterates over the specified collection, and adds each element returned by the iterator to this queue, in turn. A runtime exception encountered while trying to add an element (including, in particular, a `null` element) may result in only some of the elements having been successfully added when the associated exception is thrown.

    Specified by:
      `addAll` in interface `Collection<E>`
    Overrides:
      `addAll` in class `AbstractCollection<E>`
    Parameters:
      `c` - collection containing elements to be added to this queue
    Returns:
      `true` if this queue changed as a result of the call
    Throws:
      `ClassCastException` - if the class of an element of the specified collection prevents it from being added to this queue
      `NullPointerException` - if the specified collection contains a null element and this queue does not permit null elements, or if the specified collection is null
      `IllegalArgumentException` - if some property of an element of the specified collection prevents it from being added to this queue, or if the specified collection is this queue
      `IllegalStateException` - if not all the elements can be added at this time due to insertion restrictions
    See Also:
      - `add(Object)`